Program IR_Dos;
{ Programm zur Demonstration von IR_Lernen und IR_Senden  }
{ Guenther Teuschler, ea472@fen.baynet.de, 23. Maerz 1999 }

Uses SIO;
Var
  f : Text;
  i : Integer;
  Name_Taste : String;
  c : Char;

Procedure Timing;
{ ermittelt die Timing-Werte }
Var
  COMx : Integer;
  XSIO_Kanal : LongInt;
  XAbfallzeit_IR_Detektor,  SonyS1, SonyS2 : LongInt;
  Delay_Drehg_msec, Anfragen_pSec, PNr, PAbweichung, PQuote : LongInt;
  Fehlercode : String;
Begin
  XAbfallzeit_IR_Detektor := 80;
  SonyS1 := 0; SonyS2 := 0;     { werden hier nicht gebraucht }
  Assign(f,'timing.txt');{$I-} Reset(f); {$I+}
  If IOResult <> 0 then
  Begin
    WriteLn('Datei timing.dat wird erstellt');
    Repeat
      Write('ComPort ? (1..4) '); ReadLn(COMx);
    Until COMx in [1..4];
    WriteLn('Das dauert ca. 30 sec.');
    XSIO_Kanal:=COMx;
    Sio_Info ( XSIO_Kanal, Delay_Drehg_msec, Anfragen_pSec,
	     XAbfallzeit_IR_Detektor,  SonyS1, SonyS2);
    Bestimme_Drehzahl (
	Delay_Drehg_msec, Anfragen_pSec, PNr, PAbweichung, PQuote ,
	Fehlercode ) ;
    If Fehlercode <> '' then
    Begin
      WriteLn('Fehlercode="',Fehlercode,'"');
      Halt;
    End;
    Rewrite(f);
    WriteLn(f,COMx:10);
    WriteLn(f,Delay_Drehg_mSec:10);
    WriteLn(f,Anfragen_pSec:10);
    WriteLn(f,XAbfallzeit_IR_Detektor:10);
  End
  Else
  Begin
    Reset(f);
    ReadLn(f,COMx);
    ReadLn(f,Delay_Drehg_mSec);
    ReadLn(f,Anfragen_pSec);
    ReadLn(f,XAbfallzeit_IR_Detektor);
    XSIO_Kanal:=COMx;
    Close(f);
  End;
  Sio_Info ( XSIO_Kanal, Delay_Drehg_msec, Anfragen_pSec,
    XAbfallzeit_IR_Detektor,  SonyS1, SonyS2);
End;

Procedure Lerne_IR(Taste : string);
Var
  XL_Befehl : TIR_Befehl;
    XL_Code, XL_Error, XL_Kommentar : String;
Begin
  WriteLn('Bitte "',Taste,'"-Taste drcken!');
  IR_Lernen ( XL_Befehl,
		XL_Code, XL_Error, XL_Kommentar );
  WriteLn('XL_Error     ',XL_Error);
  WriteLn('XL-Kommentar ',XL_Kommentar);
  Assign(f,Taste+'.dat');
  Rewrite(f);
  WriteLn(f,Taste);
  WriteLn(f,XL_Code);
  i := 0;
  WriteLn(f,XL_Befehl.IR_Muster[i]:8,i:5);
  Repeat
    inc(i);
    WriteLn(f,XL_Befehl.IR_Muster[i]:8,i:5);
  Until XL_Befehl.IR_Muster[i] = 0;
  Close(f);
End;

Procedure Sende_IR(Taste : string);
var
  XS_Befehl : TIR_Befehl;
  XL_Code : String;
Begin
  Assign(f,Taste+'.dat');
  Reset(f);
  ReadLn(f,Taste);
  ReadLn(f,XL_Code);
  i := 0;
  ReadLn(f,XS_Befehl.IR_Muster[i]);
  Repeat
    inc(i);
    ReadLn(f,XS_Befehl.IR_Muster[i]);
  Until XS_Befehl.IR_Muster[i] = 0;
  Close(f);
  IR_Senden ( XS_Befehl );
End;

Function Pruefe (Name : String) : Boolean;
{ prft, ob Name zulssig ist }
Var
  len : Integer;
  i   : Integer;
  c   : Char;
  res : Boolean;
Begin
  len := length(Name);
  res := len <= 8;
  i:=0;
  while res and (i < len) do
  Begin
    inc(i); c:=Name[i];
    res := res and ((UpCase(c) in ['A'..'Z']) or (c in ['0'..'9']));
  End;
  If not res then WriteLn('Name unzulssig!');
  Pruefe:=res;
End;

Function File_Exist (Name:String) : Boolean;
Begin
  Assign(f,Name+'.dat'); {$I-} Reset(f); {$I+}
  If IOResult <> 0 Then
  Begin
    WriteLn('keine IR-Daten fr ',Name,' vorhanden!');
    File_Exist := false;
  End
  Else
  Begin
    File_Exist := true;
    Close(f);
  End;
End;

Begin
  Timing;
  Repeat
    Write('[l]ernen / [s]enden / [q]uitt '); ReadLn(c);
    case UpCase(c) of
    'L' : Begin
	    Write('Name der Taste ? '); ReadLn(Name_Taste);
	    If Pruefe(Name_Taste) then Lerne_IR(Name_Taste);
	 End;
    'S' : Begin
	    Write('Name der Taste ? '); ReadLn(Name_Taste);
	    If Pruefe(Name_Taste) and File_Exist(Name_Taste) then
	      Sende_IR(Name_Taste);
	  End;
    'Q' : Halt;
    End;
  Until false;
End.

